package com.chinaitop.depot.business.controller;

import java.util.List;

import javax.annotation.Resource;

import org.springframework.http.MediaType;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;

import com.chinaitop.depot.business.model.BusinessMergeNotice;
import com.chinaitop.depot.business.model.BusinessMergeNoticeDetail;
import com.chinaitop.depot.business.service.BusinessMergeNoticeService;

import io.swagger.annotations.Api;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;

@RestController
@RequestMapping(value="/depot/business/businessMergeNotice")
@Api(value= "BusinessMergeNoticeController", description = "合并通知单管理")
public class BusinessMergeNoticeController {

	@Resource
	private BusinessMergeNoticeService businessMergeNoticeService;

	@RequestMapping(value="/findByHtbhCondition",produces = MediaType.APPLICATION_JSON_VALUE,  method=RequestMethod.GET)
	@ApiOperation(value="根据合同编号获取通知单数据列表", notes = "")
	@ApiImplicitParams({
		@ApiImplicitParam(name = "htbh", value = "合同编号", required=true, paramType = "query"),
		@ApiImplicitParam(name = "orgId", value = "库ID", required=true, paramType = "query")
	})
    public List<BusinessMergeNoticeDetail> findByHtbhCondition(String htbh, Integer orgId) {
		List<BusinessMergeNoticeDetail> list = businessMergeNoticeService.findByHtbhCondition(htbh, orgId);
        return list;
    }
}
