package com.chinaitop.depot.business.service.impl;

import java.math.BigDecimal;
import java.util.List;
import java.util.stream.Collectors;

import javax.annotation.Resource;

import org.springframework.stereotype.Service;
import org.springframework.util.ObjectUtils;

import com.chinaitop.depot.agile.model.BusinessScedule;
import com.chinaitop.depot.business.mapper.BusinessMergeNoticeMapper;
import com.chinaitop.depot.business.model.BusinessMergeNotice;
import com.chinaitop.depot.business.model.BusinessMergeNoticeDetail;
import com.chinaitop.depot.business.service.BusinessMergeNoticeService;
import com.chinaitop.depot.business.service.FeignAgileService;

@Service
public class BusinessMergeNoticeServiceImpl implements BusinessMergeNoticeService {

	@Resource
	private BusinessMergeNoticeMapper businessMergeNoticeMapper;
	@Resource
	private FeignAgileService feignAgileService;

	@Override
	public List<BusinessMergeNoticeDetail> findByHtbhCondition(String htbh, Integer orgId) {
		BusinessMergeNoticeDetail obj = new BusinessMergeNoticeDetail();
		obj.setOrgId(orgId);
		obj.setHtbh(htbh);
		List<BusinessMergeNoticeDetail> tzd_list = businessMergeNoticeMapper.findByHtbhCondition(obj);
		if (!ObjectUtils.isEmpty(tzd_list)) {
			// 通过通知单id,去出入库查询.
			List<String> tzdid_list = tzd_list.stream().map(BusinessMergeNoticeDetail::getTzdid).collect(Collectors.toList());
			String tzdid_str = "('"+String.join("','", tzdid_list)+"')";
			List<BusinessScedule> businessSceduleList = feignAgileService.getNoticeSceduleInNoticeId(tzdid_str);
            if (businessSceduleList != null && businessSceduleList.size() > 0) {
            	for (BusinessMergeNoticeDetail d : tzd_list) {
            		// 循环出入库，查询的list.
            		d.setSysl(new BigDecimal("0"));//先设置为0， 避免没有查到数据显示为空的情况
                    for (BusinessScedule businessScedule : businessSceduleList) {
                    	if (d.getTzdid().equals(businessScedule.getTzdId())) {

                    		BigDecimal s = new BigDecimal(1000);
                    		BigDecimal sumSysl = new BigDecimal(businessScedule.getSumSysl()).divide(s).setScale(3, BigDecimal.ROUND_DOWN);
                    		d.setSysl(sumSysl);

                			// 在出入库list中删除该数据，这样下次循环数量就会减少了.
                			businessSceduleList.remove(businessScedule);
                			// 跳出当前的出入库循环.
                			break;
                    	}
                    }
            	}
            } else {
            	for (BusinessMergeNoticeDetail d : tzd_list) {
            		d.setSysl(new BigDecimal("0"));
            	}
            }
		}
		return tzd_list;
	}

}
